//+------------------------------------------------------------------+
//|                                                    Aliens_DB.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright   "FF Aliens thread"
#property link        "http://www.forexfactory.com/showthread.php?t=463573"
#property description "Aliens dashboard"
#property description "Many people contributed to this dashboard,"
#property description "thanks to all!"
#property version     "1.01"
#property strict

#include <stdlib.mqh>
#include <stderror.mqh>
#include <NewsInc_V2.0.mqh> 

input string s___general				= "-------     General Settings     -------";	
input string objectPreamble         = "Aliens_db_";
input int dbUpdateFrequency         = 5;
input string prefixPairName         = "";
input string postfixPairName        = "";
input int xAnchor                   = 10;
input int yAnchor                   = 75;
input int rowHeight                 = 20;
input double spreadLevel            = 3.5;
input bool useNewsFilter            = true;
input int minutesBeforeNews         = 30;
input int minutesAfterNews          = 15;
input int fontSize_2                = 8;
input int fontSize_Currency         = 9;

input string s___ADX_15				   = "-------     ADX_15 Settings     -------";
input bool ADX_15_M5_Active         = false;
input bool ADX_15_M15_Active        = false;
input bool ADX_15_H1_Active         = true;
input bool ADX_15_H4_Active         = true;
input bool ADX_15_sendEmail         = false;
input bool ADX_15_sendNotification  = false;
input ENUM_TIMEFRAMES ADX_15_UpdateFreq = PERIOD_M5;

input string s___DDS				      = "-------     Delayed Stoch Settings     -------";
input bool DDS_M5_Crossings_Active  = false;
input bool DDS_M15_Crossings_Active = false;
input bool DDS_H1_Crossings_Active  = true;
input bool DDS_H4_Crossings_Active  = true;
input bool DDS_D1_Crossings_Active  = true;
input bool DDS_W1_Crossings_Active  = true;
input bool DDS_sendEmail            = false;
input bool DDS_sendNotification     = false;
input ENUM_TIMEFRAMES DDSUpdateFreq = PERIOD_M5;	


#define BullColor clrLime
#define BearColor clrOrangeRed

#define SHIFT_0 0
#define SHIFT_1 1
#define SHIFT_2 2
#define SHIFT_3 3

/* -----------------------------------------------------------
   enumeration ADX_STATE
   ----------------------------------------------------------- */
enum ADX_STATE {
	ADX_NONE = 0,			// undefined condition
	ADX_WEAK_BULL = 1,	// weak bullish condition
	ADX_WEAK_BEAR = -1,	// weak bearish condition
	ADX_BULL = 2,			// strong bullish condition
	ADX_BEAR = -2			// strong bearish condition
};

/* -----------------------------------------------------------
   enumeration RSIOMA_STATE
   ----------------------------------------------------------- */
enum RSIOMA_ENUM {
	RSIOMA_UP = 3,			
	RSIOMA_DOWN = -3,
	RSIOMA_NEUTRAL = 0,
	RSIOMA_ABOVE_80 = 2,
	RSIOMA_ABOVE_50 = 1,
	RSIOMA_BELOW_50 = -1,
	RSIOMA_BELOW_20 = -2		
};

struct adx_struct
{
   int adx_7;
   int adx_21;
   int adx_42;
   int adx_89;
   int adx_144;
};

struct rsioma_struct
{
   int rsiOma_Value;
   int rsiOma_Region;
   int rsiOma_Direction;
};


struct pair_data
{
   string pairName;
   bool pairInList;
   
   double MyPoint;
   double MyDigits;
   double MyMultiplier;
   
   double pBid;
   double pAsk;
   double spread;
   
   string Base;
   string Quote;
   
   double adrValue;
   int newsInfo;
   
   rsioma_struct W1;
   rsioma_struct D1;
   rsioma_struct H4;
   rsioma_struct H1;
   rsioma_struct M15;
   rsioma_struct M5;
   
   adx_struct adx_D1;
   adx_struct adx_H4;
   adx_struct adx_H1;
   adx_struct adx_M15;
   adx_struct adx_M5;
   
   ADX_STATE adxState_M5;
   ADX_STATE adxState_M15;
   ADX_STATE adxState_H1;
   ADX_STATE adxState_H4;
   
   bool DDS_Cross_Active;

};
pair_data pairData[];

string DefaultPairs[] = {  "AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","CADCHF",
                           "CADJPY","CHFJPY","EURAUD","EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURUSD",
                           "GBPAUD","GBPCAD","GBPCHF","GBPJPY","GBPNZD","GBPUSD","NZDCAD","NZDCHF",
                           "NZDJPY","NZDUSD","USDCAD","USDCHF","USDJPY"
                        };
string Currencies[] = {"EUR", "GBP", "AUD", "NZD", "CHF", "CAD", "JPY", "USD"};

bool ExcludeSundayData = true;
bool disableRankingRsiOma = true;

// date time parameters as calculation triggers
static datetime newM1Bar = 0;
static datetime newTF_1 = 0;
static datetime newTF_2 = 0;
static datetime newTF_ADX_15_M5;
static datetime newTF_ADX_15_M15;
static datetime newTF_ADX_15_H1;
static datetime newTF_ADX_15_H4;
static datetime newH4Bar = 0;
static datetime DDS_Update_Timer;

static datetime newTF_DDS_M5;
static datetime newTF_DDS_M15;
static datetime newTF_DDS_H1;
static datetime newTF_DDS_H4;
static datetime newTF_DDS_D1;
static datetime newTF_DDS_W1;



// parameters for visual presentation of db
int panelWidth_1 = 75;
int panelHeight_1 = rowHeight;
int borderWidth_1 = 1;
int textOffset_1 = 1;
int fontSize_1 = 9;

int widthColumn_2 = 40;
int offsetColumn_2 = panelWidth_1;
int widthColumn_3 = 40;
int offsetColumn_3 = offsetColumn_2 + widthColumn_2 + 2;
int widthColumn_4 = 40;
int offsetColumn_4 = offsetColumn_3 + widthColumn_3 + 2;

int widthColumn_5 = 98;
int offsetColumn_5 = offsetColumn_4 + widthColumn_4 + 12;
int widthColumn_6 = 113;
int offsetColumn_6 = offsetColumn_5 + widthColumn_5 + 12;
int widthColumn_7 = 85;
int offsetColumn_7 = offsetColumn_6 + widthColumn_6 + 2;
int widthColumn_8 = 85;
int offsetColumn_8 = offsetColumn_7 + widthColumn_7 + 2;

int widthColumn_9 = 25;
int offsetColumn_9 = offsetColumn_8 + widthColumn_8 + 12;
int widthColumn_10 = 25;
int offsetColumn_10 = offsetColumn_9 + widthColumn_9 + 2;
int widthColumn_11 = 30;
int offsetColumn_11 = offsetColumn_10 + widthColumn_10 + 2;
int widthColumn_12 = 30;
int offsetColumn_12 = offsetColumn_11 + widthColumn_11 + 2;
int widthColumn_13 = 50;
int offsetColumn_13 = offsetColumn_12 + widthColumn_12 + 2;

int widthBuySell_16 = 50;          // buttons
int offsetBuy = 920;
int offsetSell = 962;
int offsetClose = 939;

color pairBackground = clrRosyBrown;
color pairForeground = clrWhite;
color pairBorder = clrLightGray;
color columnColorUp = clrGreen;
color columnColorNeutral = clrBlack;
color columnColorDown = clrRed;
color clrHeaders = C'0,60,255';

color headerBackground = clrCornflowerBlue;
color mainPanelBackground = clrBlack;

color defaultBackground = clrWhiteSmoke;

string panelName, labelName;



//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
//--- create timer
   EventSetTimer(dbUpdateFrequency);
   
   // delete objects
   string name;
   string s = objectPreamble;
 
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
   }
   
   // set basic data for all pairs
   ArrayResize(pairData,ArraySize(DefaultPairs));
   for (int u = 0; u < ArraySize(DefaultPairs); u++)
   {
      // build pair names and check for blanks
      string rawPair = prefixPairName + DefaultPairs[u] + postfixPairName;
      pairData[u].pairName = StringTrim(rawPair, " ");
      
      // calculate multiplier for pips calculation based on broker digits
      pairData[u].MyDigits = MarketInfo(pairData[u].pairName,MODE_DIGITS);
      pairData[u].MyPoint = MarketInfo(pairData[u].pairName,MODE_POINT);
      if( pairData[u].MyDigits == 3 || pairData[u].MyDigits == 5 ) pairData[u].MyPoint = pairData[u].MyPoint * 10;
      
      if (pairData[u].MyPoint != 0.0)
      {
         pairData[u].MyMultiplier = 1.0 / pairData[u].MyPoint;
         pairData[u].pairInList = true;
      } 
      else
      {
         pairData[u].MyMultiplier = 0.0;
         pairData[u].pairInList = false;
      }
      
      pairData[u].Base = StringSubstr(DefaultPairs[u],0,3);
      pairData[u].Quote = StringSubstr(DefaultPairs[u],3,3);
   }
   
   // set framework for db
   setFramework();
   
   //
   newH4Bar = 0;
   newM1Bar = 0;
   
   newTF_ADX_15_M5 = 0;
   newTF_ADX_15_M15 = 0;
   newTF_ADX_15_H1 = 0;
   newTF_ADX_15_H4 = 0;
   newTF_DDS_M5 = 0;
   newTF_DDS_M15 = 0;
   newTF_DDS_H1 = 0;
   newTF_DDS_H4 = 0;
   newTF_DDS_D1 = 0;
   newTF_DDS_W1 = 0;
   
   DDS_Update_Timer = 0;
   
   ExternalNewsInit();
      
//---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//--- destroy timer
   EventKillTimer();
   
   // delete objects
   string name;
   string s = objectPreamble;
 
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
        name = ObjectName(i);
        if (StringSubstr(name, 0, StringLen(s)) == s)
        {
            ObjectDelete(name);
        }
   }
      
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---

   // only if trades are open
   
}
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
{
//---

   if (useNewsFilter)
   {
      setNews();
   }
   displaySpreads();
   displayPFO();
   displayADR();
   displayRsiOma();
   displayDDS();
   
   // ADX 15 signals
   if (newTF_ADX_15_M5 != iTime(Symbol(), PERIOD_M5, 0))
   {
      newTF_ADX_15_M5 = iTime(Symbol(), PERIOD_M5, 0);
      if (ADX_15_M5_Active)
      {
         display_calculate_ADX_15(PERIOD_M5);
      }
   }
   if (newTF_ADX_15_M15 != iTime(Symbol(), PERIOD_M15, 0))
   {
      newTF_ADX_15_M15 = iTime(Symbol(), PERIOD_M15, 0);
      if (ADX_15_M15_Active)
      {
         display_calculate_ADX_15(PERIOD_M15);
      }
   }
   if (newTF_ADX_15_H1 != iTime(Symbol(), PERIOD_H1, 0))
   {
      newTF_ADX_15_H1 = iTime(Symbol(), PERIOD_H1, 0);
      if (ADX_15_H1_Active)
      {
         display_calculate_ADX_15(PERIOD_H1);
      }
   }
   if (newTF_ADX_15_H4 != iTime(Symbol(), PERIOD_H4, 0))
   {
      newTF_ADX_15_H4 = iTime(Symbol(), PERIOD_H4, 0);
      if (ADX_15_H4_Active)
      {
         display_calculate_ADX_15(PERIOD_H4);
      }
   }
}


void display_calculate_ADX_15(ENUM_TIMEFRAMES _TF)
{
   ADX_STATE _p15[15];
   ADX_STATE _pp15[15];
   int _periods[] = {7, 21, 42, 63, 89, 144, 267, 336, 432, 504, 1068, 1728, 2016, 4272, 6912};
   double main_1, main_2, main_3, plus_1, plus_2, plus_3, min_1, min_2, min_3;
   double diThres = 0.0;
	double adxTrendLimit = 0.0001;
   
   // calculate all 15 adx values
   for (int z = 0; z < ArraySize(DefaultPairs); z++)
   {
      for (int zz = 0; zz <15; zz++)
      {
         main_1 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MAIN, SHIFT_1);
         plus_1 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_PLUSDI, SHIFT_1);
         min_1 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MINUSDI, SHIFT_1);
         
         main_2 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MAIN, SHIFT_2);
         plus_2 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_PLUSDI, SHIFT_2);
         min_2 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MINUSDI, SHIFT_2);
         
         main_3 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MAIN, SHIFT_3);
         plus_3 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_PLUSDI, SHIFT_3);
         min_3 = iADX(pairData[z].pairName, _TF, _periods[zz], PRICE_CLOSE, MODE_MINUSDI, SHIFT_3);
         
         double tmp = plus_1 - min_1;
         _p15[zz] = ADX_NONE;
         if (main_1 - main_2 > adxTrendLimit) 
   		{
      		if (plus_1 > min_1) {
      			_p15[zz] = ADX_BULL;
      		}
      		else if (plus_1 < min_1) {
      			_p15[zz] = ADX_BEAR;
      		}
      	}
      	else 
      	{
      		if (tmp > diThres) {
      			_p15[zz] = ADX_WEAK_BULL;
      		}
      		else if (tmp < -diThres) {
      			_p15[zz] = ADX_WEAK_BEAR;
      		}
      	}
      	
      	tmp = plus_2 - min_2;
         _pp15[zz] = ADX_NONE;
         if (main_2 - main_3 > adxTrendLimit) 
   		{
      		if (plus_2 > min_2) {
      			_pp15[zz] = ADX_BULL;
      		}
      		else if (plus_2 < min_2) {
      			_pp15[zz] = ADX_BEAR;
      		}
      	}
      	else 
      	{
      		if (tmp > diThres) {
      			_pp15[zz] = ADX_WEAK_BULL;
      		}
      		else if (tmp < -diThres) {
      			_pp15[zz] = ADX_WEAK_BEAR;
      		}
      	}
      }
      
      // Evaluate the results
      int counter_1 = 0;
      int counter_2 = 0;
      
      //check for all up
      for (int q = 0; q < 15; q++)
      {
         if (_p15[q] > 0)
         {
            counter_1++;
         }
         if (_pp15[q] > 0)
         {
            counter_2++;
         }
      }
      if (counter_1 == 15 && counter_2 < 15)
      {
         Alert("ADX 15(ebitalebi) strategy up trigger for symbol: " + 
            pairData[z].pairName + " and TF: " + IntegerToString(_TF,1) + " and time: " + Time[0]);
      }
      
      counter_1 = 0;
      counter_2 = 0;
      //check for all down
      for (int q = 0; q < 15; q++)
      {
         if (_p15[q] < 0)
         {
            counter_1++;
         }
         if (_pp15[q] < 0)
         {
            counter_2++;
         }
      }
      if (counter_1 == 15 && counter_2 < 15)
      {
         Alert("ADX 15(ebitalebi) strategy down trigger for symbol: " + 
            pairData[z].pairName + " and TF: " + IntegerToString(_TF,1) + " and time: " + Time[0]);
      }
   }
}
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   
  }
//+------------------------------------------------------------------+

void SetPanel(string name,int sub_window,int x,int y,int width,int height,color bg_color,color border_clr,int border_width)
  {
   if(ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
     }
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }
  
void SetObjText(string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,0,0,0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }
  
void SetText(string name,string text,int x,int y,color colour,int fontsize)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,0,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_FONT,"Arial");
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }
  
  void SetArrow ( string name, int x, int y, color col, int arrowSize, int dir)
  {
      if (ObjectFind(0,name)<0)
      {
         ObjectCreate(0,name,OBJ_LABEL,0,0,0);
      }
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_COLOR,col);
      ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
      ObjectSetInteger(0,name,OBJPROP_FONTSIZE,arrowSize);
      if (dir == 1)
      {
         ObjectSetInteger(0,name,OBJPROP_COLOR,clrGreen);
         ObjectSetString(0,name,OBJPROP_TEXT,CharToStr(233));
      }
      else if (dir == -1)
      {
         ObjectSetInteger(0,name,OBJPROP_COLOR,clrRed);
         ObjectSetString(0,name,OBJPROP_TEXT,CharToStr(234));
      }
      else
      {
         ObjectSetInteger(0,name,OBJPROP_COLOR,clrGold);
         ObjectSetString(0,name,OBJPROP_TEXT,CharToStr(104));
      }
  }

void setFramework()
{
    // set the headers for the table
    panelName = objectPreamble + "panelheaderOverall1";
    SetPanel(panelName,0,xAnchor,yAnchor - 50, 200, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall1";
    SetText(labelName," Alien's Extraterrestrial DB",xAnchor +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);
    
    panelName = objectPreamble + "panelheaderOverall2";
    SetPanel(panelName,0,xAnchor + offsetColumn_5,yAnchor - 50, widthColumn_5, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall2";
    SetText(labelName,"RsiOma",xAnchor + offsetColumn_5 +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);
    
    panelName = objectPreamble + "panelheaderOverall3";
    SetPanel(panelName,0,xAnchor + offsetColumn_6,yAnchor - 50, widthColumn_6, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall3";
    SetText(labelName,"Delayed Stoch",xAnchor + offsetColumn_6 +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);
    
    /*    panelName = objectPreamble + "panelheaderOverall4";
    SetPanel(panelName,0,xAnchor + offsetColumn_7,yAnchor - 50, 85, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall4";
    SetText(labelName,"Adx 89.144",xAnchor + offsetColumn_7 +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);

    panelName = objectPreamble + "panelheaderOverall5";
    SetPanel(panelName,0,xAnchor + offsetColumn_8,yAnchor - 50, 85, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall5";
    SetText(labelName,"Stoch D.",xAnchor + offsetColumn_8 +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);
    
    panelName = objectPreamble + "panelheaderOverall6";
    SetPanel(panelName,0,xAnchor + offsetColumn_9,yAnchor - 50, 52, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    labelName = objectPreamble + "labelheaderOverall6";  
    SetText(labelName,"Cross",xAnchor + offsetColumn_9 +  5, yAnchor - 51 + textOffset_1,pairForeground,fontSize_1);
    */
    
    // display pair names
   for (int u = 0; u < 28; u++)
   {
      panelName = objectPreamble + "panelPairName_1_" + pairData[u].pairName;
      labelName = objectPreamble + "labelPairName_1_" + pairData[u].pairName;
      SetPanel(panelName,0,xAnchor,yAnchor + u * (panelHeight_1 + borderWidth_1),panelWidth_1 - 5, panelHeight_1,clrAzure,pairBorder,borderWidth_1);
      SetText(labelName,pairData[u].pairName,xAnchor + 5, yAnchor + u * (panelHeight_1 + borderWidth_1) + textOffset_1,clrBlack,fontSize_1);    
   }
   
   // subheaders
    panelName = objectPreamble + "panelheaderPairName";
    labelName = objectPreamble + "labelheaderPairName";
    SetPanel(panelName,0,xAnchor,yAnchor - 25,panelWidth_1 - 5, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
    SetText(labelName,"Pair",xAnchor + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);


   panelName = objectPreamble + "panelheaderSprd";
   labelName = objectPreamble + "labelheaderSprd";
   SetPanel(panelName,0,xAnchor + offsetColumn_2, yAnchor - 25, widthColumn_2, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
   SetText(labelName,"Sp.",xAnchor + offsetColumn_2 + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);
    
   panelName = objectPreamble + "panelheaderPFO";
   labelName = objectPreamble + "labelheaderPFO";
   SetPanel(panelName,0,xAnchor + offsetColumn_3,yAnchor - 25,widthColumn_3, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
   SetText(labelName,"PfO",xAnchor + offsetColumn_3 + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);
   
   panelName = objectPreamble + "panelheaderADR";
   labelName = objectPreamble + "labelheaderADR";
   SetPanel(panelName,0,xAnchor + offsetColumn_4,yAnchor - 25,widthColumn_4, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
   SetText(labelName,"ADR",xAnchor + offsetColumn_4 + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);
   
   panelName = objectPreamble + "panelheaderRsiOma";
   labelName = objectPreamble + "labelheaderRsiOma";
   SetPanel(panelName,0,xAnchor + offsetColumn_5,yAnchor - 25, widthColumn_5, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
   SetText(labelName,"W1...M5",xAnchor + offsetColumn_5 + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);

   panelName = objectPreamble + "panelheaderDDS";
   labelName = objectPreamble + "labelheaderDDS";
   SetPanel(panelName,0,xAnchor + offsetColumn_6,yAnchor - 25, widthColumn_6, panelHeight_1,clrHeaders,pairBorder,borderWidth_1);
   SetText(labelName,"W1...M5",xAnchor + offsetColumn_6 + 5, yAnchor - 25 + textOffset_1,pairForeground,fontSize_1);

}

color ColorSpread(double tot) 
{
   if(tot <= spreadLevel)
      return (BullColor);
   if(tot > spreadLevel)
      return (BearColor);
   return (clrOrange);
}

color ColorPlusMinus(double tot) 
{
   if(tot >= 0)
      return (BullColor);
   if(tot < 0)
      return (BearColor);
   return (clrOrange);
}

color getImpactColor(int value, color _default)
{
   if (value == 0) {return _default;}
   if (value == 1) {return clrRed;}
   if (value == 2) {return clrOrange;}
   if (value == 3) {return clrYellow;}
   return _default;
}

void displaySpreads()
{
   // calculate and display Spread
   for (int m = 0; m < 28; m++)
   {
      panelName = objectPreamble + "panelSpread_" + pairData[m].pairName;
      labelName = objectPreamble + "labelSpread_" + pairData[m].pairName;
      pairData[m].pBid = MarketInfo(pairData[m].pairName, MODE_BID);
      pairData[m].pAsk = MarketInfo(pairData[m].pairName, MODE_ASK);
      double value = (-pairData[m].pBid + pairData[m].pAsk);
      value = value * pairData[m].MyMultiplier;
      pairData[m].spread = value;
      string strValue = DoubleToString(value, 1);
      SetPanel(panelName,0,xAnchor + offsetColumn_2,yAnchor + m * (panelHeight_1 + borderWidth_1),widthColumn_2, panelHeight_1, clrBlack, pairBorder,borderWidth_1);
      SetText(labelName,strValue, xAnchor + offsetColumn_2 + 5, yAnchor + m * (panelHeight_1 + borderWidth_1) + textOffset_1, ColorSpread(strValue),fontSize_2);
   }
}

void displayPFO()    // Pips from Open
{
   // PFO
   int tmpInt = 0;
   for (int kk = 0; kk < 28; kk++)
   {
      panelName = objectPreamble + "panelDO_" + pairData[kk].pairName;
      labelName = objectPreamble + "labelDO_" + pairData[kk].pairName;
      SetPanel(panelName,0,xAnchor + offsetColumn_3 ,yAnchor + kk * (panelHeight_1 + borderWidth_1),widthColumn_3, panelHeight_1, clrBlack, pairBorder,borderWidth_1);
      double value = (pairData[kk].pAsk + pairData[kk].pBid)/ 2;
      //Alert(pairValues[kk].MyPoint);
      value = (value - iOpen(pairData[kk].pairName,PERIOD_D1,0)) * pairData[kk].MyMultiplier;
      tmpInt = MathRound(value);
      if (MathAbs(value) > (pairData[kk].adrValue * 0.9))
      {
         SetText(labelName,IntegerToString(tmpInt,0),xAnchor + offsetColumn_3 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + textOffset_1,clrBlack,fontSize_2);
         ObjectSetInteger(0,panelName,OBJPROP_BGCOLOR,clrOrangeRed);
      }
      else
      {
         SetText(labelName,IntegerToString(tmpInt,0),xAnchor + offsetColumn_3 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + textOffset_1,ColorPlusMinus(tmpInt),fontSize_2);
         ObjectSetInteger(0,panelName,OBJPROP_BGCOLOR,clrBlack);
      }
   }
}

void displayADR()
{
   // adr
   if (newH4Bar != iTime(Symbol(), PERIOD_H4, 0))
   {
      newH4Bar = iTime(Symbol(), PERIOD_H4, 0);
      // ADR
      for (int l = 0; l < 28; l++)
      {
         int n=1;  
         static int adr1,adr5,adr10,adr20,adr;
         double s=0.0;    
         for(int ll=1;ll<=20;ll++)
         {
            while(ExcludeSundayData && TimeDayOfWeek(iTime(pairData[l].pairName,PERIOD_D1,n))==0) n++;
            s=s + ( iHigh(pairData[l].pairName,PERIOD_D1,n) - iLow(pairData[l].pairName,PERIOD_D1,n) ) * pairData[l].MyMultiplier;
            if(ll==1) adr1=MathRound(s);
            if(ll==5) adr5=MathRound(s/5);
            if(ll==10) adr10=MathRound(s/10);
            if(ll==20) adr20=MathRound(s/20);
            n++;  
         }  
         adr  = MathRound((adr1+adr5+adr10+adr20)/4.0);
         pairData[l].adrValue = adr;
         panelName = objectPreamble + "panelAdr_" + pairData[l].pairName;
         labelName = objectPreamble + "labelAdr_" + pairData[l].pairName;
         SetPanel(panelName,0,xAnchor + offsetColumn_4,yAnchor + l * (panelHeight_1 + borderWidth_1),widthColumn_4, panelHeight_1, clrBlack, pairBorder,borderWidth_1);
         SetText(labelName,IntegerToString(adr,0), xAnchor + offsetColumn_4 + 5, yAnchor + l * (panelHeight_1 + borderWidth_1) + textOffset_1, clrOrange,fontSize_2);
      }
   }
}

void displayRsiOma()
{
   int fontSizeTest = 14;
   int offsetSquare = -3;
   double value_1, value_2, value_3;
   for (int kk = 0; kk < 28; kk++)
   {
      panelName = objectPreamble + "panelRsiOma_W1_" + pairData[kk].pairName;
      labelName = objectPreamble + "labelRsiOma_W1_" + pairData[kk].pairName;
      SetPanel(panelName,0,xAnchor + offsetColumn_5 ,yAnchor + kk * (panelHeight_1 + borderWidth_1),widthColumn_5, panelHeight_1, clrBlack, pairBorder,borderWidth_1);
      value_1 = iCustom(pairData[kk].pairName,PERIOD_W1,"RSIOMA (2)", 14, 1, 0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_W1,"RSIOMA (2)", 14, 1, 5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_W1,"RSIOMA (2)", 14, 1, 0, 1);
      //Alert(value_2);
      pairData[kk].W1.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 6, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 6, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 6, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 5, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 6, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 2, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].W1.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].W1.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 6, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      
      panelName = objectPreamble + "panelRsiOma_D1_" + pairData[kk].pairName;
      labelName = objectPreamble + "labelRsiOma_D1_" + pairData[kk].pairName;
      SetPanel(panelName,0,xAnchor + offsetColumn_5 ,yAnchor + kk * (panelHeight_1 + borderWidth_1),widthColumn_5, panelHeight_1, clrBlack, pairBorder,borderWidth_1);
      value_1 = iCustom(pairData[kk].pairName,PERIOD_D1,"RSIOMA (2)", 14, 1,  0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_D1,"RSIOMA (2)", 14, 1,  5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_D1,"RSIOMA (2)", 14, 1,  0, 1);
      //Alert(value_2);
      pairData[kk].D1.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 21, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 20, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 21, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 20, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 20, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 21, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 20, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 21, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 17, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].D1.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].D1.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 21, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      
      value_1 = iCustom(pairData[kk].pairName,PERIOD_H4,"RSIOMA (2)", 14, 1,  0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_H4,"RSIOMA (2)", 14, 1,  5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_H4,"RSIOMA (2)", 14, 1,  0, 1);
      labelName = objectPreamble + "labelRsiOma_H4_" + pairData[kk].pairName;
      //Alert(value_2);
      pairData[kk].H4.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 36, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 35, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 36, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 35, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 35, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 36, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 35, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 36, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 32, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].H4.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].H4.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 36, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }

      value_1 = iCustom(pairData[kk].pairName,PERIOD_H1,"RSIOMA (2)", 14, 1,  0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_H1,"RSIOMA (2)", 14, 1, 5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_H1,"RSIOMA (2)", 14, 1,  0, 1);
      labelName = objectPreamble + "labelRsiOma_H1_" + pairData[kk].pairName;
      //Alert(value_2);
      pairData[kk].H1.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 51, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 50, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 51, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 50, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 50, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 51, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 50, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 51, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 47, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].H1.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].H1.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 51, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      
      value_1 = iCustom(pairData[kk].pairName,PERIOD_M15,"RSIOMA (2)",  14, 1, 0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_M15,"RSIOMA (2)",  14, 1, 5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_M15,"RSIOMA (2)",  14, 1, 0, 1);
      labelName = objectPreamble + "labelRsiOma_M15_" + pairData[kk].pairName;
      //Alert(value_2);
      pairData[kk].M15.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 66, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 65, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 66, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 65, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 65, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 66, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 65, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 66, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 62, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].M15.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].M15.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 66, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      
      value_1 = iCustom(pairData[kk].pairName,PERIOD_M5,"RSIOMA (2)",  14, 1, 0, 0);
      value_2 = iCustom(pairData[kk].pairName,PERIOD_M5,"RSIOMA (2)",  14, 1, 5, 0);
      value_3 = iCustom(pairData[kk].pairName,PERIOD_M5,"RSIOMA (2)",  14, 1, 0, 1);
      labelName = objectPreamble + "labelRsiOma_M5_" + pairData[kk].pairName;
      //Alert(value_2);
      pairData[kk].M5.rsiOma_Value = value_1;
      if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 81, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 80.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_ABOVE_80;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 80, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_UP;
         //SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 81, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 > value_2 || disableRankingRsiOma) && value_1 > 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrGreen, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_ABOVE_50;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_DOWN;
         SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 80, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1)  + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 80, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 20.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_BELOW_20;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 81, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 < value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_DOWN;
         //SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_5 + 80, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
      }
      else if ((value_1 < value_2 || disableRankingRsiOma) && value_1 < 50.0 && value_1 > value_3)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_BELOW_50;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_UP;
         SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_5 + 81, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
      else
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_5 + 77, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrGold, fontSizeTest);
         pairData[kk].M5.rsiOma_Region = RSIOMA_NEUTRAL;
         pairData[kk].M5.rsiOma_Direction = RSIOMA_NEUTRAL;
         SetObjText(labelName + "_arrow",CharToStr(243),xAnchor + offsetColumn_5 + 81, yAnchor + kk * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
      }
   }

}

void setNews()
{
   int tmpLevel;
   for ( int z = 0; z < 28; z++)
   {
      panelName = objectPreamble + "panelPairName_1_" + pairData[z].pairName;
      labelName = objectPreamble + "labelPairName_1_" + pairData[z].pairName;
      tmpLevel = getNewsInfoPair(pairData[z].pairName, minutesBeforeNews, minutesAfterNews);
      pairData[z].newsInfo = tmpLevel;
      color tmpColor = getImpactColor(tmpLevel,defaultBackground);
      ObjectSetInteger(0,panelName,OBJPROP_BGCOLOR, tmpColor);
      ObjectSetInteger(0, labelName,OBJPROP_COLOR,clrBlack);
   }
}

void displayDDS()
{

   double value_1, value_2, value_3, value_4, value_5, value_6;
   string tmpString;
   string _message;
   int fontSizeTest = 14;
   int offsetSquare = -3;
   if (DDS_Update_Timer != iTime("", DDSUpdateFreq, 0))
   {
      DDS_Update_Timer = iTime("", DDSUpdateFreq, 0);
   }
   else
   {
      return;
   }
   
   for (int ll = 0; ll < ArraySize(pairData); ll++)
   {
      pairData[ll].DDS_Cross_Active = false;
      
      panelName = objectPreamble + "panelDDS_" + pairData[ll].pairName;
      SetPanel(panelName,0,xAnchor + offsetColumn_6 ,yAnchor +ll * (panelHeight_1 + borderWidth_1),widthColumn_6, panelHeight_1, clrBlack, pairBorder,borderWidth_1);

      labelName = objectPreamble + "labelDDS_W1_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_W1,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_W1_Crossings_Active)
         {
            if (newTF_DDS_W1 != iTime("EURUSD", PERIOD_W1, 0))
            {
               newTF_DDS_W1 = iTime("EURUSD", PERIOD_W1, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: W1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB", _message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_W1_Crossings_Active)
         {
            if (newTF_DDS_W1 != iTime("EURUSD", PERIOD_W1, 0))
            {
               newTF_DDS_W1 = iTime("EURUSD", PERIOD_W1, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: W1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 2, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 5, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 2, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 5, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 2, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 5, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 2, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 5, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      /////////
      labelName = objectPreamble + "labelDDS_D1_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_D1,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_D1_Crossings_Active)
         {
            if (newTF_DDS_D1 != iTime("EURUSD", PERIOD_D1, 0))
            {
               newTF_DDS_D1 = iTime("EURUSD", PERIOD_D1, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: D1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_D1_Crossings_Active)
         {
            if (newTF_DDS_D1 != iTime("EURUSD", PERIOD_D1, 0))
            {
               newTF_DDS_D1 = iTime("EURUSD", PERIOD_D1, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: D1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 17, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 20, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 17, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 20, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 17, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 20, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 17, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 20, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      
      /////////
      labelName = objectPreamble + "labelDDS_H4_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_H4,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_H4_Crossings_Active)
         {
            if (newTF_DDS_H4 != iTime("EURUSD", PERIOD_H4, 0))
            {
               newTF_DDS_H4 = iTime("EURUSD", PERIOD_H4, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: H4" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_W1_Crossings_Active)
         {
            if (newTF_DDS_H4 != iTime("EURUSD", PERIOD_H4, 0))
            {
               newTF_DDS_H4 = iTime("EURUSD", PERIOD_H4, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: H4" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 32, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 35, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 32, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 35, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 32, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 35, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 32, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 35, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      
      /////////
      labelName = objectPreamble + "labelDDS_H1_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_H1,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_H1_Crossings_Active)
         {
            if (newTF_DDS_H1 != iTime("EURUSD", PERIOD_H1, 0))
            {
               newTF_DDS_H1 = iTime("EURUSD", PERIOD_H1, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: H1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_H1_Crossings_Active)
         {
            if (newTF_DDS_H1 != iTime("EURUSD", PERIOD_H1, 0))
            {
               newTF_DDS_H1 = iTime("EURUSD", PERIOD_H1, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: H1" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 47, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 50, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 47, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 50, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 47, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 50, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 47, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 50, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      
      /////////
      labelName = objectPreamble + "labelDDS_M15_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_M15,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_M15_Crossings_Active)
         {
            if (newTF_DDS_M15 != iTime("EURUSD", PERIOD_M15, 0))
            {
               newTF_DDS_M15 = iTime("EURUSD", PERIOD_M15, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: M15" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_W1_Crossings_Active)
         {
            if (newTF_DDS_M15 != iTime("EURUSD", PERIOD_M15, 0))
            {
               newTF_DDS_M15 = iTime("EURUSD", PERIOD_M15, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: M15" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 62, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 65, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 62, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 65, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 62, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 65, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 62, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 65, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      
      /////////
      labelName = objectPreamble + "labelDDS_M5_" + pairData[ll].pairName;
      value_1 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 0, 0);
      value_2 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 1, 0);
      value_3 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 0, 1);
      value_4 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 1, 1);
      value_5 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 0, 2);
      value_6 = iCustom(DefaultPairs[ll], PERIOD_M5,"DDS", 8, 13, 9, 1, 2);
      tmpString = DoubleToString(value_1);
      
      //check if cross active
      if (value_3 > value_4 && value_5 < value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_M5_Crossings_Active)
         {
            if (newTF_DDS_M5 != iTime("EURUSD", PERIOD_M5, 0))
            {
               newTF_DDS_M5 = iTime("EURUSD", PERIOD_M5, 0);
               // Alert
               _message = "DDS up cross for symbol: " + pairData[ll].pairName + " for TF: M5" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      else if (value_3 < value_4 && value_5 > value_6)
      {
         pairData[ll].DDS_Cross_Active = true;
         if (DDS_M5_Crossings_Active)
         {
            if (newTF_DDS_M5 != iTime("EURUSD", PERIOD_M5, 0))
            {
               newTF_DDS_M5 = iTime("EURUSD", PERIOD_M5, 0);
               // Alert
               _message = "DDS down cross for symbol: " + pairData[ll].pairName + " for TF: M5" ;
               Alert(_message);
               if (DDS_sendEmail){send_Email("Alien DB",_message); }
               if (DDS_sendNotification){send_Notification("Alien DB",_message); }
            }   
         }
      }
      
      if ( value_1 > 80)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 77, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrLime, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 80, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 > 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 77, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrGreen, fontSizeTest);
         if (value_1 < value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(234),xAnchor + offsetColumn_6 + 80, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 4, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 20)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 77, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrRed, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 80, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      else if (value_1 < 50)
      {
         SetObjText(labelName,CharToStr(110),xAnchor + offsetColumn_6 + 77, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare, clrOrange, fontSizeTest);
         if (value_1 > value_3)
         {
            SetObjText(labelName + "_arrow",CharToStr(233),xAnchor + offsetColumn_6 + 80, yAnchor + ll * (panelHeight_1 + borderWidth_1) + 2, clrBlack, fontSize_2-1);
         }
      }
      
      // check for setting across picto
      labelName = objectPreamble + "labelDDS_Cross_" + pairData[ll].pairName;
      if (pairData[ll].DDS_Cross_Active)
      {
         SetObjText(labelName,CharToStr(253),xAnchor + offsetColumn_6 + 94, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare + 4, clrOrange, fontSizeTest-3);
      }
      else
      {
         SetObjText(labelName,CharToStr(32),xAnchor + offsetColumn_6 + 94, yAnchor + ll * (panelHeight_1 + borderWidth_1) + offsetSquare + 3, clrOrange, fontSizeTest-3);
      }
   }
}

//+------------------------------------------------------------------+
string StringTrim(string str, string _char=" ")
//+------------------------------------------------------------------+
// Copied from Hanover
// Removes all spaces (leading, traing embedded) from a string
// Usage:    string x=StringTrim("The Quick Brown Fox")  returns x = "TheQuickBrownFox"
// char defaults to space(s), but may contain a list of characters to be stripped
{
  string outstr = "";
  for(int i=0; i<StringLen(str); i++)  {
    if (StringFind(_char,StringSubstr(str,i,1)) < 0)
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}

void send_Email(string _header, string _emailMessage)
{
   bool bResult =  SendMail( 
   _header,       // header 
   _emailMessage      // email text 
   );
   
   if (!bResult)
   {
      int errorCode = GetLastError();
      Alert("Error sending email, error code: " + errorCode);
   }
}

void send_Notification(string _header, string _pushMessage)
{
   bool bResult = SendNotification( 
   _header + " - " + _pushMessage          // Text of the notification 
   );
   
   if (!bResult)
   {
      int errorCode = GetLastError();
      Alert("Error sending push notification, error code: " + errorCode);
   }
}
